#include <vector>
#include "histogram.h"
#include "histogram_internal.h"
using namespace std;


void find_minmax(const vector<double>& numbers, double& min, double& max) {
    max = 0;
    if (numbers.size() != 0) {
        min = numbers[0];
        max = numbers[0];
        for (auto el : numbers) {
            if (el > max) {
                max = el;
            }
            if (el < min) {
                min = el;
            }
        }
    } else {min = 0;}
}

vector<size_t> make_histogram(const vector<double>& numbers, size_t bin_count) {
    vector<size_t> bins(bin_count);
    double max, min;
    find_minmax(numbers, min, max);
    double binSize = (max - min) / bin_count;
    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * binSize;
            auto hi = min + (j + 1) * binSize;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}
