#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"
#include <vector>
#include "svg.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("NULL vector") {
    double min = 0;
    double max = 0;
    find_minmax({1,2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}
TEST_CASE("vector with one elements") {
    double min = 0;
    double max = 0;
    find_minmax({1, 1}, min, max);
    CHECK(min == 1);
    CHECK(max == 1);
}
TEST_CASE("distinct negative numbers") {
    double min = 0;
    double max = 0;
    find_minmax({-1, -2}, min, max);
    CHECK(min == -2);
    CHECK(max == -1);
}

TEST_CASE("svg_check") {
size_t max_count = 5;
size_t bin_count = 3;
std::vector <double> test;
std::vector<size_t> bins = {2, 5, 3};
std::vector <double> prover = {404, 300, 20, 4, 405, 4, 10, 4, 10, 94, 405, 4, 405, 98, 20, 98, 405, 98};
show_histogram_svg(bins, max_count, bin_count, test);
CHECK(test==prover);
}
